@echo off

rem ****************************************************************************
rem ** 
rem ** SYNTAX: BUILD_VS r|c|d win32|x64 folder-name project-name
rem ** 
rem ** BUILD_VS uses Visual Studio 2008 to compile the specified project. 
rem ** 
rem ** r|c|d: one of the configurations `Release', `Checked Release' or `Debug'
rem ** win32|x64: one of the supported target platforms
rem ** 
rem ****************************************************************************

if "%1" equ "" goto :eof

set TARGETPATH=

set VS2008=
if "%ProgramFiles(x86)%" equ "" set ProgramFiles(x86)=%ProgramFiles%
call "%~dp0..\setenv.bat"
if "%VS2008%" equ "" goto :no_vs2008

set VS2008_DEVENV=%VS2008%\Common7\IDE\devenv.exe
if exist "%VS2008_DEVENV%" goto devenv_exists
set VS2008_DEVENV=
goto :no_vs2008
:devenv_exists

set VS2008_CFG=
if /i "%1" equ "r" set VS2008_CFG=Release
if /i "%1" equ "c" set VS2008_CFG=Checked Release
if /i "%1" equ "d" set VS2008_CFG=Debug
if "%VS2008_CFG%" equ "" goto :no_config
set VS2008_TARGET=
if /i "%2" equ "win32" set VS2008_TARGET=Win32
if /i "%2" equ "x64" set VS2008_TARGET=x64
if "%VS2008_TARGET%" equ "" goto :no_target
set VS2008_NAME=%~3
if "%VS2008_NAME%" equ "" goto :no_name
set VS2008_PRJ=%~4
if "%VS2008_PRJ%" equ "" set VS2008_PRJ=%VS2008_NAME%

set TARGETPATH=%~dp0..\src\%VS2008_NAME%\obj\%VS2008_PRJ%\%VS2008_CFG%\%VS2008_TARGET%
"%VS2008_DEVENV%" "%~dp0..\src\%VS2008_NAME%\%VS2008_PRJ%.sln" /Upgrade
"%VS2008_DEVENV%" "%~dp0..\src\%VS2008_NAME%\%VS2008_PRJ%.sln" /build "%VS2008_CFG%|%VS2008_TARGET%" /project "%VS2008_PRJ%"
goto :eof

:no_vs2008
cls
echo.Cannot find Visual Studio 2008.
echo.Please edit the file `setenv.bat'
echo.
pause
notepad "%~dp0..\setenv.bat"
if "%__MAPDRIVE%" neq "" call "%dp0map" /D
exit 1

:no_config
:no_target
:no_name
goto :eof
